
SET CLASSLIB TO myclasses.vcx ADDITIVE

  INIT      :

IF VARTYPE(THISFORM.oData) = "O"
  REMOVEPROPERTY(THISFORM,"oData")
ENDIF

THISFORM.ADDPROPERTY("oData")
THISFORM.oData = NEWOBJECT("dataobj")

**      ,     
**    

LOCAL oHeader
oHeader = CREATEOBJECT("custom")

USE IN SELECT("theheader")

TRY

  **   adapter    

  THIS.oData.adapter( @oHeader,;
    'header',;
    'theheader',;
    .T.,;  &&  
  .T.)   &&   (  )

CATCH TO oException

  MESSAGEBOX("Error message: " + oException.MESSAGE)

ENDTRY


DEFINE CLASS DATAOBJ AS CUSTOM

  cSch         = ""
  cUnl         = ""
  cUfl         = ""
  cKeyField    = ""
  cTheAlias    = ""
  cTable       = ""
  lOK          = .T.
  cSavingTable = ""

  PROCEDURE INIT

    SET MULTILOCKS ON

    THIS.opendatabase()    &&      

  ENDPROC


  PROCEDURE DESTROY
    THIS.closealltables()  &&    
    THIS.CloseDataBase()   &&     
  ENDPROC


  PROCEDURE ERROR
    (       )
  ENDPROC


  PROCEDURE adapter
    LPARAMETERS toObject,tcTable,tcAlias,tlUpdatable,tlEmpty,tcSelectCmd,tcTableList


    LOCAL cSchema,cUfl,cUnl,lOK,cSelectCmd

    lOK = .T.


    THIS.cKeyField = THIS.getkeyfield( tcTable,tcAlias ) &&    

    *    ,  ,   SQL-

    TRY


      IF VARTYPE(tcSelectCmd) = "C"       &&   Select,    
        && 
        cSelectCmd = tcSelectCmd
        THIS.MakeSchema(tcTable,cSelectCmd,tcAlias)
      ELSE
        THIS.OPENTABLE(tcTable,tcAlias)     &&     
        && 
        THIS.MakeSchema(tcTable,'',tcAlias)
      ENDIF

    CATCH TO oException

      lOK = .F.
      MESSAGEBOX("Cursor "+tcAlias+" could not be generated"+CHR(13)+oException.MESSAGE)

    ENDTRY

    IF lOK = .F.
      RETURN
    ENDIF


    cUfl    = THIS.cUfl                        &&   
    cUnl    = THIS.cUnl         &&   
    cSchema = THIS.cSch   &&  

    THIS.CLOSETABLE(tcAlias)                   &&      

    lOK = .T.

    TRY

      IF VARTYPE( THIS.toObject ) = "O"
        REMOVEPROPERTY(THIS,"toObject")
      ENDIF


      THIS.ADDPROPERTY("toObject")
      THIS.toObject = CREATEOBJECT("cursoradapter")


    CATCH TO oErrors

      MESSAGEBOX("CursorAdapter object not generated"+;
        CHR(13)+oErrors.MESSAGE,16,"Attention",2000)

      lOK = .F.

    ENDTRY

    IF lOK = .F.
      RETURN
    ENDIF


    IF lOK = .T.
      TRY

        IF VARTYPE(tcSelectCmd) <> "C"   &&        select

          IF tlEmpty = .T.

            **   

            cSelectCmd = [select * from ] + tcTable + [ where 1 = 0 ]

          ELSE

            **   

            cSelectCmd = [select * from ] + tcTable

          ENDIF

        ELSE
          cSelectCmd = tcSelectCmd    &&   select,    
        ENDIF


        WITH THIS.toObject
          .DATASOURCETYPE           = "NATIVE"
          .ALIAS        = tcAlias
          IF VARTYPE(tcListaTablas) = "C" AND LEN(ALLTRIM(tcTableList)) > 0
            .TABLES                 = tcTableList
          ELSE
            .TABLES        = tcTable
          ENDIF
          .BUFFERMODEOVERRIDE       = 5
          .KEYFIELDLIST             = THIS.cKeyField
          .SENDUPDATES        = tlUpdatable
          .SELECTCMD        = cSelectCmd
          .UPDATABLEFIELDLIST       = cUfl
          .UPDATENAMELIST        = cUnl
          .CURSORSCHEMA             = cSchema
          .CURSORFILL()
        ENDWITH


        SELECT ( tcAlias )


      CATCH TO oErrors
        MESSAGEBOX("Cursor "+tcAlias+" was not generated"+CHR(13)+oErrors.MESSAGE;
          ,16,"Attention",3000)
        lOK = .F.

      ENDTRY
    ENDIF

    RETURN lOK
  ENDPROC


  PROCEDURE MakeSchema
    LPARAMETERS tcTable,tcSelectCmd,tcAlias

    **       updatablefieldlist   updatenamelist

    LOCAL cUnl,cSch,cUfl,cCmd
    LOCAL ARRAY aNC(1,1)

    cSch      = ""                        && 
    cUnl      = ""                        && updatenamelist
    cUfl      = ""                        && updatablefieldlist


    IF LEN(ALLTRIM(tcSelectCmd)) > 0      &&  SQL-  Select 

      cCmd = tcSelectCmd + [ into cursor ] + tcAlias


      TRY

        &cCmd


      CATCH TO oError
        THIS.mensaje("Incorrect SQL statement")
      ENDTRY


      **        
      **        SQL-

      SELECT * FROM (tcTable) INTO CURSOR temporario WHERE 1=0
      SELECT temporario
      AFIELDS( aTemp,'temporario')
      USE IN SELECT("temporario")

      FOR i = 1 TO ALEN(aTemp)/18
        cUnl = cUnl + aTemp(i,1)+" "+JUSTSTEM(tcTable)+"."+aTemp(i,1)+","
        cUfl = cUfl + aTemp(i,1)+","
      ENDFOR

      **    ,    

      SELECT (tcAlias)
      =AFIELDS(aNC,tcAlias)       &&  ,    

      FOR i = 1 TO ALEN(aNC)/18
        cSch = cSch + aNC(i,1)+" "+aNC(i,2)
        DO CASE
          CASE INLIST(aNC(i,2),"C","D","L","M","I","T")
            cSch = cSch + "(" +TRANSFORM(aNC(i,3)) +")"
          CASE aNC(i,2) = "N"
            cSch = cSch + "(" +TRANSFORM(aNC(i,3))+","+TRANSFORM(aNC(i,4)) +")"
        ENDCASE
        cSch = cSch + ","
      ENDFOR

    ELSE

      SELECT (tcAlias)
      =AFIELDS(aNC,tcAlias)       &&  ,    

      FOR i = 1 TO ALEN(aNC)/18
        cSch = cSch + aNC(i,1)+" "+aNC(i,2)
        cUnl = cUnl + aNC(i,1)+" "+JUSTSTEM(tcTable)+"."+aNC(i,1)+","
        cUfl = cUfl + aNC(i,1)+","
        DO CASE
          CASE INLIST(aNC(i,2),"C","D","L","M","I","T")
            cSch = cSch + "(" +TRANSFORM(aNC(i,3)) +")"
          CASE aNC(i,2) = "N"
            cSch = cSch + "(" +TRANSFORM(aNC(i,3))+","+TRANSFORM(aNC(i,4)) +")"
        ENDCASE
        cSch = cSch + ","
      ENDFOR

    ENDIF

    **     

    THIS.cSch = SUBSTR(cSch,1,LEN(ALLTRIM(cSch))-1)   && 
    THIS.cUnl = SUBSTR(cUnl,1,LEN(ALLTRIM(cUnl))-1)   && updatenamelist
    THIS.cUfl = SUBSTR(cUfl,1,LEN(ALLTRIM(cUfl))-1)   && updatablefieldlist

  ENDPROC


  PROCEDURE getkeyfield
    LPARAMETERS tcTable,tcAlias

    LOCAL cKeyField


    THIS.OPENTABLE (tcTable,tcAlias)


    SELECT (tcAlias)


    FOR i = 1 TO TAGCOUNT()
      IF PRIMARY(i) OR CANDIDATE(i)
        cKeyField = TAG(i)
        EXIT
      ENDIF
    ENDFOR

    THIS.CLOSETABLE (tcAlias)

    RETURN cKeyField
  ENDPROC


  PROCEDURE COMMIT
    LPARAMETERS tcAlias

    **   tableupdate      

    LOCAL cAlias
    DIMENSION aErrorArray(1)

    cAlias = tcAlias


    SELECT (cAlias)


    THIS.lOK = TABLEUPDATE(1,.T.,(cAlias))


    IF THIS.lOK = .F.

      =AERROR(aErrorArray)  &&     

      MESSAGEBOX(aErrorArray(2)+CHR(13)+;
        "Error Nbr: "+ TRANSFORM(aErrorArray(1))+CHR(13)+;
        "Table: "+THIS.cAlias +CHR(13)+CHR(13)+;
        "Not saved" )


    ENDIF

    RETURN THIS.lOK

  ENDPROC


ENDDEFINE
